/***************************************************************************
                          confdialog.cpp  -  description
                             -------------------
    begin                : May 7 22:18:34 BST 2004
    copyright            : (C) 2004 by KSmoothDock team
    email                : dangvd@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>

#include "confdialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qslider.h>
#include <kcolorbutton.h>
#include <knuminput.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include <kmessagebox.h>

#include "constants.h"
#include "ksmoothdock.h"


/*
 *  Constructs a ConfDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ConfDialog::ConfDialog( KSmoothDock* parent, const char* name, bool modal, WFlags fl )
    : QDialog( (QWidget*) parent, name, modal, fl )
{
    this->parent = parent;
    if ( !name )
	    setName( "KSmoothDock Preferences" );
    setSizeGripEnabled( TRUE );

    buttonApply = new QPushButton( this, "buttonApply" );
    buttonApply->setGeometry( QRect( 140, 530, 130, 30 ) );
    buttonApply->setAutoDefault( TRUE );
    buttonApply->setDefault( TRUE );

    buttonQuit = new QPushButton( this, "buttonQuit" );
    buttonQuit->setGeometry( QRect( 370, 530, 110, 30 ) );
    buttonQuit->setAutoDefault( TRUE );

    tabPrefs = new QTabWidget( this, "tabPrefs" );
    tabPrefs->setGeometry( QRect( 20, 10, 570, 500 ) );    

    Widget3 = new QWidget( tabPrefs, "Widget3" );

    groupBox2 = new QGroupBox( Widget3, "groupBox2" );
    groupBox2->setGeometry( QRect( 30, 30, 490, 250 ) );

    textLabel1_3 = new QLabel( groupBox2, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 160, 160, 261, 41 ) );

    textLabel2_3 = new QLabel( groupBox2, "textLabel2_3" );
    textLabel2_3->setGeometry( QRect( 80, 130, 131, 31 ) );

    textLabel7 = new QLabel( groupBox2, "textLabel7" );
    textLabel7->setGeometry( QRect( 80, 80, 171, 31 ) );

    textLabel9 = new QLabel( groupBox2, "textLabel9" );
    textLabel9->setGeometry( QRect( 80, 200, 141, 41 ) );

    textLabel6 = new QLabel( groupBox2, "textLabel6" );
    textLabel6->setGeometry( QRect( 80, 20, 340, 41 ) );

    cbQuickLaunch = new QCheckBox( groupBox2, "cbQuickLaunch" );
    cbQuickLaunch->setEnabled( FALSE );
    cbQuickLaunch->setGeometry( QRect( 30, 30, 20, 21 ) );
    cbQuickLaunch->setChecked( TRUE );

    cbPager = new QCheckBox( groupBox2, "cbPager" );
    cbPager->setGeometry( QRect( 30, 80, 20, 20 ) );

    cbTaskbar = new QCheckBox( groupBox2, "cbTaskbar" );
    cbTaskbar->setGeometry( QRect( 30, 130, 20, 20 ) );

    cbClock = new QCheckBox( groupBox2, "cbClock" );
    cbClock->setGeometry( QRect( 30, 210, 20, 20 ) );

    cbShowWinAllDesks = new QCheckBox( groupBox2, "cbShowWinAllDesks" );
    cbShowWinAllDesks->setGeometry( QRect( 110, 170, 20, 20 ) );
    tabPrefs->insertTab( Widget3, QString("") );
		
		Widget2 = new QWidget( tabPrefs, "Widget2" );

    groupBox1 = new QGroupBox( Widget2, "groupBox1" );
    groupBox1->setGeometry( QRect( 30, 30, 431, 160 ) );

    buttonGroup2 = new QButtonGroup( groupBox1, "buttonGroup2" );
    buttonGroup2->setGeometry( QRect( 10, 50, 360, 90 ) );
    buttonGroup2->setLineWidth( 0 );

    textLabel3 = new QLabel( buttonGroup2, "textLabel3" );
    textLabel3->setGeometry( QRect( 130, -5, 221, 41 ) );

    textLabel4 = new QLabel( buttonGroup2, "textLabel4" );
    textLabel4->setGeometry( QRect( 130, 40, 180, 40 ) );

    rbNormalZoom = new QRadioButton( buttonGroup2, "rbNormalZoom" );
    rbNormalZoom->setGeometry( QRect( 80, 0, 16, 31 ) );

    rbParabolicZoom = new QRadioButton( buttonGroup2, "rbParabolicZoom" );
    rbParabolicZoom->setGeometry( QRect( 80, 45, 16, 31 ) );
		
		textLabel1_2 = new QLabel( Widget2, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 30, 210, 431, 60 ) );
    tabPrefs->insertTab( Widget2, QString("") );

    TabPage = new QWidget( tabPrefs, "TabPage" );

    groupBox3 = new QGroupBox( TabPage, "groupBox3" );
    groupBox3->setGeometry( QRect( 30, 30, 510, 150 ) );

    textLabel2_2_2 = new QLabel( groupBox3, "textLabel2_2_2" );
    textLabel2_2_2->setGeometry( QRect( 20, 90, 131, 31 ) );

    textLabel2_2 = new QLabel( groupBox3, "textLabel2_2" );
    textLabel2_2->setGeometry( QRect( 20, 40, 131, 31 ) );

    edtSmallIconNZ = new QLineEdit( groupBox3, "edtSmallIconNZ" );
    edtSmallIconNZ->setGeometry( QRect( 429, 38, 51, 31 ) );
    edtSmallIconNZ->setReadOnly( TRUE );

    edtBigIconNZ = new QLineEdit( groupBox3, "edtBigIconNZ" );
    edtBigIconNZ->setGeometry( QRect( 430, 90, 51, 31 ) );
    edtBigIconNZ->setReadOnly( TRUE );

    sldSmallIconNZ = new QSlider( groupBox3, "sldSmallIconNZ" );
    sldSmallIconNZ->setGeometry( QRect( 160, 40, 241, 24 ) );
    sldSmallIconNZ->setOrientation( QSlider::Horizontal );
//    sldSmallIconNZ->setTickmarks( QSlider::Below );
    sldSmallIconNZ->setMinValue(16);
    sldSmallIconNZ->setMaxValue(48);

    sldBigIconNZ = new QSlider( groupBox3, "sldBigIconNZ" );
    sldBigIconNZ->setGeometry( QRect( 160, 90, 241, 24 ) );
    sldBigIconNZ->setOrientation( QSlider::Horizontal );
//    sldBigIconNZ->setTickmarks( QSlider::Below );
    sldBigIconNZ->setMinValue(24);
    sldBigIconNZ->setMaxValue(64);

    groupBox4 = new QGroupBox( TabPage, "groupBox4" );
    groupBox4->setGeometry( QRect( 30, 220, 510, 140 ) );

    textLabel2_2_3 = new QLabel( groupBox4, "textLabel2_2_3" );
    textLabel2_2_3->setGeometry( QRect( 20, 30, 131, 31 ) );

    textLabel2_2_2_2 = new QLabel( groupBox4, "textLabel2_2_2_2" );
    textLabel2_2_2_2->setGeometry( QRect( 20, 80, 110, 31 ) );

    edtBigIconPZ = new QLineEdit( groupBox4, "edtBigIconPZ" );
    edtBigIconPZ->setGeometry( QRect( 430, 80, 51, 31 ) );
    edtBigIconPZ->setReadOnly( TRUE );

    edtSmallIconPZ = new QLineEdit( groupBox4, "edtSmallIconPZ" );
    edtSmallIconPZ->setGeometry( QRect( 430, 30, 51, 31 ) );
    edtSmallIconPZ->setReadOnly( TRUE );

    sldSmallIconPZ = new QSlider( groupBox4, "sldSmallIconPZ" );
    sldSmallIconPZ->setGeometry( QRect( 160, 30, 241, 24 ) );
    sldSmallIconPZ->setOrientation( QSlider::Horizontal );
//    sldSmallIconPZ->setTickmarks( QSlider::Below );
    sldSmallIconPZ->setMinValue(16);
    sldSmallIconPZ->setMaxValue(48);

    sldBigIconPZ = new QSlider( groupBox4, "sldBigIconPZ" );
    sldBigIconPZ->setGeometry( QRect( 160, 80, 241, 24 ) );
    sldBigIconPZ->setOrientation( QSlider::Horizontal );
//    sldBigIconPZ->setTickmarks( QSlider::Below );
    sldBigIconPZ->setMinValue(32);
    sldBigIconPZ->setMaxValue(144);
    
    tabPrefs->insertTab( TabPage, QString("") );


    TabPage_2 = new QWidget( tabPrefs, "TabPage_2" );

    groupBox5 = new QGroupBox( TabPage_2, "groupBox5" );
    groupBox5->setGeometry( QRect( 50, 10, 420, 130 ) );

    textLabel3_2 = new QLabel( groupBox5, "textLabel3_2" );
    textLabel3_2->setGeometry( QRect( 71, 32, 121, 31 ) );

    textLabel4_2 = new QLabel( groupBox5, "textLabel4_2" );
    textLabel4_2->setGeometry( QRect( 130, 80, 110, 31 ) );

    cbBorders = new QCheckBox( groupBox5, "cbBorders" );
    cbBorders->setGeometry( QRect( 30, 40, 20, 30 ) );

    btnBorderColor = new KColorButton( groupBox5, "btnBorderColor" );
    btnBorderColor->setGeometry( QRect( 250, 70, 60, 40 ) );

    groupBox6 = new QGroupBox( TabPage_2, "groupBox6" );
    groupBox6->setGeometry( QRect( 50, 160, 420, 290 ) );

    textLabel6_2 = new QLabel( groupBox6, "textLabel6_2" );
    textLabel6_2->setGeometry( QRect( 40, 80, 131, 41 ) );

    textLabel7_2 = new QLabel( groupBox6, "textLabel7_2" );
    textLabel7_2->setGeometry( QRect( 40, 120, 171, 51 ) );

    textLabel8 = new QLabel( groupBox6, "textLabel8" );
    textLabel8->setGeometry( QRect( 40, 220, 151, 51 ) );

    textLabel5_2 = new QLabel( groupBox6, "textLabel5_2" );
    textLabel5_2->setGeometry( QRect( 40, 40, 141, 31 ) );

    textLabel7_2_2 = new QLabel( groupBox6, "textLabel7_2_2" );
    textLabel7_2_2->setGeometry( QRect( 40, 170, 171, 51 ) );

    btnBgColor = new KColorButton( groupBox6, "btnBgColor" );
    btnBgColor->setGeometry( QRect( 250, 30, 60, 40 ) );

    btnSepColor = new KColorButton( groupBox6, "btnSepColor" );
    btnSepColor->setGeometry( QRect( 250, 80, 60, 40 ) );

    btnActiveDeskColor = new KColorButton( groupBox6, "btnActiveDeskColor" );
    btnActiveDeskColor->setGeometry( QRect( 250, 130, 60, 40 ) );

    btnInactiveDeskColor = new KColorButton( groupBox6, "btnInactiveDeskColor" );
    btnInactiveDeskColor->setGeometry( QRect( 250, 180, 60, 40 ) );

    btnClockTextColor = new KColorButton( groupBox6, "btnClockTextColor" );
    btnClockTextColor->setGeometry( QRect( 250, 230, 60, 40 ) );
    tabPrefs->insertTab( TabPage_2, QString("") );

    TabPage_3 = new QWidget( tabPrefs, "TabPage_3" );

    groupBox7 = new QGroupBox( TabPage_3, "groupBox7" );
    groupBox7->setGeometry( QRect( 30, 30, 510, 71 ) );

    textLabel9_2 = new QLabel( groupBox7, "textLabel9_2" );
    textLabel9_2->setGeometry( QRect( 60, 30, 395, 31 ) );

    cbNotification = new QCheckBox( groupBox7, "cbNotification" );
    cbNotification->setGeometry( QRect( 30, 30, 20, 20 ) );

    groupBox9 = new QGroupBox( TabPage_3, "groupBox9" );
    groupBox9->setGeometry( QRect( 30, 250, 510, 130 ) );

    textLabel1 = new QLabel( groupBox9, "textLabel1" );
    textLabel1->setGeometry( QRect( 60, 30, 201, 31 ) );

    textLabel11 = new QLabel( groupBox9, "textLabel11" );
    textLabel11->setGeometry( QRect( 100, 70, 200, 31 ) );

    intScrWidth = new KIntNumInput( groupBox9, "intScrWidth" );
    intScrWidth->setGeometry( QRect( 340, 70, 113, 27 ) );

    cbXinerama = new QCheckBox( groupBox9, "cbXinerama" );
    cbXinerama->setGeometry( QRect( 30, 30, 20, 20 ) );

    groupBox10 = new QGroupBox( TabPage_3, "groupBox10" );
    groupBox10->setGeometry( QRect( 30, 130, 510, 90 ) );

    textLabel10 = new QLabel( groupBox10, "textLabel10" );
    textLabel10->setGeometry( QRect( 30, 30, 110, 40 ) );

    edtOpacity = new QLineEdit( groupBox10, "edtOpacity" );
    edtOpacity->setGeometry( QRect( 430, 30, 51, 31 ) );
    edtOpacity->setReadOnly( TRUE );

    sldOpacity = new QSlider( groupBox10, "sldOpacity" );
    sldOpacity->setGeometry( QRect( 150, 40, 251, 24 ) );
    sldOpacity->setMaxValue( 100 );
    sldOpacity->setOrientation( QSlider::Horizontal );
//    sldOpacity->setTickmarks( QSlider::Below );
    sldOpacity->setTickInterval( 0 );
    tabPrefs->insertTab( TabPage_3, QString("") );
    languageChange();
    resize( QSize(611, 574).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // init values

    if (cbTaskbar->isChecked()) {
      cbShowWinAllDesks->setEnabled(true);
    } else {
      cbShowWinAllDesks->setEnabled(false);
    }

    if (cbBorders->isChecked()) {
      btnBorderColor->setEnabled(true);
    } else {
      btnBorderColor->setEnabled(false);
    }

    if (cbXinerama->isChecked()) {
      intScrWidth->setEnabled(true);
    } else {
      intScrWidth->setEnabled(false);
    }

    // init values of slider displays
    
    edtOpacity->setText(QString::number(sldOpacity->value()));
    edtSmallIconNZ->setText(QString::number(sldSmallIconNZ->value()));
    edtBigIconNZ->setText(QString::number(sldBigIconNZ->value()));
    edtSmallIconPZ->setText(QString::number(sldSmallIconPZ->value()));
    edtBigIconPZ->setText(QString::number(sldBigIconPZ->value()));

    // signals and slots connections

    connect( cbTaskbar, SIGNAL( stateChanged(int) ), this, SLOT( cbTaskbar_stateChanged(int) ) );
    connect( buttonQuit, SIGNAL( clicked() ), this, SLOT( buttonQuit_clicked() ) );
    connect( cbBorders, SIGNAL( stateChanged(int) ), this, SLOT( cbBorders_stateChanged(int) ) );
    connect( cbXinerama, SIGNAL( stateChanged(int) ), this, SLOT( cbXinerama_stateChanged(int) ) );
    connect( buttonApply, SIGNAL( clicked() ), this, SLOT( buttonApply_clicked() ) );
    connect( sldOpacity, SIGNAL( valueChanged(int) ), this, SLOT( sldOpacity_valueChanged(int) ) );
    connect( sldSmallIconNZ, SIGNAL( valueChanged(int) ), this, SLOT( sldSmallIconNZ_valueChanged(int) ) );
    connect( sldBigIconNZ, SIGNAL( valueChanged(int) ), this, SLOT( sldBigIconNZ_valueChanged(int) ) );
    connect( sldSmallIconPZ, SIGNAL( valueChanged(int) ), this, SLOT( sldSmallIconPZ_valueChanged(int) ) );
    connect( sldBigIconPZ, SIGNAL( valueChanged(int) ), this, SLOT( sldBigIconPZ_valueChanged(int) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ConfDialog::~ConfDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ConfDialog::languageChange()
{
    setCaption( tr2i18n( "KSmoothDock Preferences" ) );
    buttonApply->setText( tr2i18n( "&Apply" ) );
    buttonApply->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    buttonQuit->setText( tr2i18n( "&Close" ) );
    buttonQuit->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
    groupBox1->setTitle( tr2i18n( "The zooming mode you want to use" ) );
    buttonGroup2->setTitle( QString::null );
    textLabel3->setText( tr2i18n( "Normal Smooth Zooming Mode" ) );
    textLabel4->setText( tr2i18n( "Parabolic Zooming Mode" ) );
    rbNormalZoom->setText( tr2i18n( "radioButton1" ) );
    rbParabolicZoom->setText( tr2i18n( "radioButton2" ) );
		textLabel1_2->setText( tr2i18n( "<font color=\"#aa0000\">Note: This option requires the dock to restart for the change to take effect.</font>" ) );
    tabPrefs->changeTab( Widget2, tr2i18n( "Zooming Mode" ) );
    groupBox2->setTitle( tr2i18n( "The components of KSmoothDock you want to use" ) );
    textLabel1_3->setText( tr2i18n( "Show windows from all desktops" ) );
    textLabel2_3->setText( tr2i18n( "Taskbar" ) );
    textLabel7->setText( tr2i18n( "Pager" ) );
    textLabel9->setText( tr2i18n( "Clock" ) );
    textLabel6->setText( tr2i18n( "Quick launch menu (always enabled by default)" ) );
    cbQuickLaunch->setText( QString::null );
    cbPager->setText( QString::null );
    cbTaskbar->setText( tr2i18n( "checkBox3" ) );
    cbClock->setText( tr2i18n( "checkBox4" ) );
    cbShowWinAllDesks->setText( tr2i18n( "checkBox5" ) );
    tabPrefs->changeTab( Widget3, tr2i18n( "Dock Components" ) );
    groupBox3->setTitle( tr2i18n( "Normal Zooming Mode" ) );
    textLabel2_2_2->setText( tr2i18n( "Big Icon Size" ) );
    textLabel2_2->setText( tr2i18n( "Small Icon Size" ) );
    groupBox4->setTitle( tr2i18n( "Parabolic Zooming Mode" ) );
    textLabel2_2_3->setText( tr2i18n( "Small Icon Size" ) );
    textLabel2_2_2_2->setText( tr2i18n( "Big Icon Size" ) );
    tabPrefs->changeTab( TabPage, tr2i18n( "Icon Sizes" ) );
    groupBox5->setTitle( tr2i18n( "Borders" ) );
    textLabel3_2->setText( tr2i18n( "Show borders" ) );
    textLabel4_2->setText( tr2i18n( "Borders color" ) );
    cbBorders->setText( tr2i18n( "checkBox8" ) );
    btnBorderColor->setText( QString::null );
    groupBox6->setTitle( tr2i18n( "Colors" ) );
    textLabel6_2->setText( tr2i18n( "Separator color" ) );
    textLabel7_2->setText( tr2i18n( "Active desktop color" ) );
    textLabel8->setText( tr2i18n( "Clock text color" ) );
    textLabel5_2->setText( tr2i18n( "Background color" ) );
    textLabel7_2_2->setText( tr2i18n( "Inactive desktop color" ) );
    btnBgColor->setText( QString::null );
    btnSepColor->setText( QString::null );
    btnActiveDeskColor->setText( QString::null );
    btnInactiveDeskColor->setText( QString::null );
    btnClockTextColor->setText( QString::null );
    tabPrefs->changeTab( TabPage_2, tr2i18n( "Appearances" ) );
    groupBox7->setTitle( tr2i18n( "Notification" ) );
    textLabel9_2->setText( tr2i18n( "Show notification when a running task's window title changed" ) );
    cbNotification->setText( tr2i18n( "checkBox9" ) );
    groupBox9->setTitle( tr2i18n( "Xinerama support" ) );
    textLabel1->setText( tr2i18n( "Enable Xinerama support" ) );
    textLabel11->setText( tr2i18n( "Left monitor's screen width" ) );
    groupBox10->setTitle( tr2i18n( "Opacity" ) );
    textLabel10->setText( tr2i18n( "Dock Opacity" ) );
    tabPrefs->changeTab( TabPage_3, tr2i18n( "Misc." ) );
}

void ConfDialog::cbTaskbar_stateChanged( int )
{
  if (cbTaskbar->isChecked()) {
    cbShowWinAllDesks->setEnabled(true);
  } else {
    cbShowWinAllDesks->setEnabled(false);
  }
}


void ConfDialog::buttonQuit_clicked()
{
    this->reject();
}

void ConfDialog::cbBorders_stateChanged( int )
{
  if (cbBorders->isChecked()) {
    btnBorderColor->setEnabled(true);
  } else {
    btnBorderColor->setEnabled(false);
  }
}

void ConfDialog::cbXinerama_stateChanged( int ) {
  if (cbXinerama->isChecked()) {
    intScrWidth->setEnabled(true);
  } else {
    intScrWidth->setEnabled(false);
  }
}


void ConfDialog::buttonApply_clicked()
{
  int i = tabPrefs->currentPageIndex();

  switch (i) {
    case 0:
			applyComponents();      
      break;
    case 1:
      applyZoomMode();
      break;
    case 2:
      applyIconSizes();
      break;
    case 3:
      applyAppearances();
      break;
    case 4:
      applyMisc();
      break;
    default:
      break;
  }
}

void ConfDialog::applyZoomMode() {
  if (getZoomMode() != parent->getZoomMode()) {
    parent->saveConf(getZoomMode());
    KMessageBox::information(this, "You need to restart the program for this change to take effect.");
  }
}

void ConfDialog::applyComponents() {
  parent->setShowPager(cbPager->isChecked());
  parent->setShowTaskbar(cbTaskbar->isChecked());
  parent->setShowWinAllDesks(cbShowWinAllDesks->isChecked());
  parent->setShowClock(cbClock->isChecked());

  parent->updateComponents();

  parent->saveConf(getZoomMode());
}

void ConfDialog::applyIconSizes() {
  bool updateDock = (parent->getZoomMode() == this->getZoomMode());
  
  parent->setSmallIconSizeNZ(sldSmallIconNZ->value());
  parent->setBigIconSizeNZ(sldBigIconNZ->value());

  parent->setSmallIconSizePZ(sldSmallIconPZ->value());
  parent->setBigIconSizePZ(sldBigIconPZ->value());

  if (updateDock) // redrawing if needed
    parent->updateIconSizes();

  parent->saveConf(getZoomMode());
}

void ConfDialog::applyAppearances() {
  bool reloadBg = (parent->getBgColor() != btnBgColor->color());
  
  parent->setShowBorders(cbBorders->isChecked());
  parent->setBorderColor(btnBorderColor->color());
     
  parent->setBgColor(btnBgColor->color());
  parent->setSepColor(btnSepColor->color());
  parent->setActiveDeskColor(btnActiveDeskColor->color());
  parent->setInactiveDeskColor(btnInactiveDeskColor->color());
  parent->setClockTextColor(btnClockTextColor->color());

  if (reloadBg) { // if the background color change we need to reload background image
    parent->updateBackground();
    parent->setStateBelow();  
  } else { // otherwise just repaint
    parent->update();
  }
  parent->saveConf(getZoomMode()); 
}

void ConfDialog::applyMisc() {
  parent->setShowNotification(cbNotification->isChecked());

  if (parent->getDockOpacity() != sldOpacity->value()) {
    parent->setDockOpacity(sldOpacity->value());
    parent->updateBackground();
    parent->setStateBelow();   
  }
  
  if (cbXinerama->isChecked()) {
    if (parent->getScrWidth() != intScrWidth->value()) {
      parent->setScrWidth(intScrWidth->value());      
      parent->updateScrWidth();
    }
  } else {
    if (parent->getScrWidth() != 0) {
      parent->setScrWidth(0);
      parent->updateScrWidth();
    }
  }
  
  parent->saveConf(getZoomMode());
}

int ConfDialog::getZoomMode() {
  if (rbNormalZoom->isChecked())
    return NORMAL_ZOOM;
  else
    return PARABOLIC_ZOOM;
}

void ConfDialog::sldOpacity_valueChanged( int )
{
    edtOpacity->setText(QString::number(sldOpacity->value()));
}


void ConfDialog::sldSmallIconNZ_valueChanged( int )
{
    edtSmallIconNZ->setText(QString::number(sldSmallIconNZ->value()));
}


void ConfDialog::sldBigIconNZ_valueChanged( int )
{
    edtBigIconNZ->setText(QString::number(sldBigIconNZ->value()));
}


void ConfDialog::sldSmallIconPZ_valueChanged( int )
{
    edtSmallIconPZ->setText(QString::number(sldSmallIconPZ->value()));
}


void ConfDialog::sldBigIconPZ_valueChanged( int )
{
    edtBigIconPZ->setText(QString::number(sldBigIconPZ->value()));
}

// update configuration values from parent

void ConfDialog::updateValues() {
  rbNormalZoom->setChecked(parent->getZoomMode() == NORMAL_ZOOM);
  rbParabolicZoom->setChecked(parent->getZoomMode() == PARABOLIC_ZOOM);

  cbPager->setChecked(parent->getShowPager());
  cbTaskbar->setChecked(parent->getShowTaskbar());
  cbShowWinAllDesks->setChecked(parent->getShowWinAllDesks());
  cbClock->setChecked(parent->getShowClock());

  sldSmallIconNZ->setValue(parent->getSmallIconSizeNZ());
  sldBigIconNZ->setValue(parent->getBigIconSizeNZ());

  sldSmallIconPZ->setValue(parent->getSmallIconSizePZ());
  sldBigIconPZ->setValue(parent->getBigIconSizePZ());

  cbBorders->setChecked(parent->getShowBorders());
  btnBorderColor->setColor(parent->getBorderColor());

  btnBgColor->setColor(parent->getBgColor());
  btnSepColor->setColor(parent->getSepColor());
  btnActiveDeskColor->setColor(parent->getActiveDeskColor());
  btnInactiveDeskColor->setColor(parent->getInactiveDeskColor());
  btnClockTextColor->setColor(parent->getClockTextColor());

  cbNotification->setChecked(parent->getShowNotification());
  sldOpacity->setValue(parent->getDockOpacity());
  cbXinerama->setChecked(parent->getScrWidth() != 0);
  intScrWidth->setValue(parent->getScrWidth());
}

