/***************************************************************************
                          confdialog.h  -  description
                             -------------------
    begin                : Tue Jun 10 22:18:34 BST 2003
    copyright            : (C) 2004 by KSmoothDock team
    email                : dangvd@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFDIALOG_H
#define CONFDIALOG_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class QTabWidget;
class QWidget;
class QGroupBox;
class QButtonGroup;
class QLabel;
class QRadioButton;
class QCheckBox;
class QLineEdit;
class QSlider;
class KColorButton;
class KIntNumInput;

class KSmoothDock;

class ConfDialog : public QDialog
{
    Q_OBJECT

public:
    ConfDialog( KSmoothDock* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ConfDialog();

    void updateValues();
    
private:
    QPushButton* buttonApply;
    QPushButton* buttonQuit;
    QTabWidget* tabPrefs;
    QWidget* Widget2;
    QGroupBox* groupBox1;
    QButtonGroup* buttonGroup2;
    QLabel* textLabel3;
    QLabel* textLabel4;
    QRadioButton* rbNormalZoom;
    QRadioButton* rbParabolicZoom;
		QLabel* textLabel1_2;
    QWidget* Widget3;
    QGroupBox* groupBox2;
    QLabel* textLabel1_3;
    QLabel* textLabel2_3;
    QLabel* textLabel7;
    QLabel* textLabel9;
    QLabel* textLabel6;
    QCheckBox* cbQuickLaunch;
    QCheckBox* cbPager;
    QCheckBox* cbTaskbar;
    QCheckBox* cbClock;
    QCheckBox* cbShowWinAllDesks;
    QWidget* TabPage;
    QGroupBox* groupBox3;
    QLabel* textLabel2_2_2;
    QLabel* textLabel2_2;
    QLineEdit* edtSmallIconNZ;
    QLineEdit* edtBigIconNZ;
    QSlider* sldSmallIconNZ;
    QSlider* sldBigIconNZ;
    QGroupBox* groupBox4;
    QLabel* textLabel2_2_3;
    QLabel* textLabel2_2_2_2;
    QLineEdit* edtBigIconPZ;
    QLineEdit* edtSmallIconPZ;
    QSlider* sldSmallIconPZ;
    QSlider* sldBigIconPZ;
    QWidget* TabPage_2;
    QGroupBox* groupBox5;
    QLabel* textLabel3_2;
    QLabel* textLabel4_2;
    QCheckBox* cbBorders;
    KColorButton* btnBorderColor;
    QGroupBox* groupBox6;
    QLabel* textLabel6_2;
    QLabel* textLabel7_2;
    QLabel* textLabel8;
    QLabel* textLabel5_2;
    QLabel* textLabel7_2_2;
    KColorButton* btnBgColor;
    KColorButton* btnSepColor;
    KColorButton* btnActiveDeskColor;
    KColorButton* btnInactiveDeskColor;
    KColorButton* btnClockTextColor;
    QWidget* TabPage_3;
    QGroupBox* groupBox7;
    QLabel* textLabel9_2;
    QCheckBox* cbNotification;
    QGroupBox* groupBox9;
    QLabel* textLabel1;
    QLabel* textLabel11;
    QCheckBox *cbXinerama;
    KIntNumInput* intScrWidth;
    QGroupBox* groupBox10;
    QLabel* textLabel10;
    QLineEdit* edtOpacity;
    QSlider* sldOpacity;

public slots:
    virtual void cbTaskbar_stateChanged( int );
    virtual void buttonQuit_clicked();
    virtual void cbBorders_stateChanged( int );
    virtual void cbXinerama_stateChanged( int );
    virtual void buttonApply_clicked();
    virtual void sldOpacity_valueChanged( int );
    virtual void sldSmallIconNZ_valueChanged( int );
    virtual void sldBigIconNZ_valueChanged( int );
    virtual void sldSmallIconPZ_valueChanged( int );
    virtual void sldBigIconPZ_valueChanged( int );

protected:

protected slots:
    virtual void languageChange();

private:
  void applyZoomMode();
  void applyComponents();
  void applyIconSizes();
  void applyAppearances();
  void applyMisc();

  int getZoomMode();
    
private:
    KSmoothDock *parent;

};

#endif // CONFDIALOG_H
